<?php
/*
    Last News : Plugin for GuppY 4.6,
    under CeCILL v2 Free Software Agreement
    Copyright (C) 2007- by  HPSAM
    Web site = http://www.hpsam.info
*/
if (stristr($_SERVER['SCRIPT_NAME'], 'function.inc')) {
  header('location:../index.php');
  die();
}
define('LN_CONFIG',CHEMIN . DATAREP . 'plugins/last_news/lnconfig');

if (is_file(LN_CONFIG . INCEXT)) include LN_CONFIG . INCEXT;

if (strpos($endurl, '/admin/') !== false) {
  include CHEMIN . 'plugins/last_news/lang/' . $lng . '-ln_adm.inc';
  include CHEMIN . 'admin/plugins/last_news/inc/ln-functionadmin.inc';
}
include(CHEMIN . 'plugins/last_news/lang/' . $lng . '-ln_web.inc');

/**
 * Use to sort by date Asc or Desc the posts in a section
 *
 * @param array $data Array from SelectRecentPostFileByStatusLN or SelectRecentForumPostByStatusLN
 *                      or SelectAgendaPostFileByStatusLN
 * @param string $order Sort order (asc or desc)
 */
function usortLN(& $data, $order) {
    if ($order == 'asc') {
        usort($data, 'usortAscLN');
    } else {
        usort($data, 'usortDescLN');
    }
}
function usortDescLN($a, $b) {
    return $a[6] > $b[6] ? +1 : -1;
}
function usortAscLN($a, $b) {
    return $a[6] < $b[6] ? +1 : -1;
}

/**
 * Replace all end of block html tags, br and hr by &#172; and delete all other html tags.
 *
 * @param string $htmlStr A string with html tags
 *
 * @return string The input string without html tags
 */
function KeepNotHtmlCharLN($htmlStr)
{
    $StrReplace = array('<br />', '<br/>', '<br>', '<hr />', '<hr/>', '<hr>', '</p>',
                        '</div>', '</h1>', '</h2>', '</h3>', '</h4>', '</h5>', '</h6>',
                        '</h7>', '</h8>');
    $Str = strip_tags(str_replace($StrReplace,' &#172; ',$htmlStr));
    return $Str;
}
/**
 * List all recent active elements (docXXX.inc) from an array of elements
 * and return an array of informations about them.
 *
 * @param array $fiels Array of array, wich came from ReadDBFields(DBType) or SelectDBFields(Type,'a','')
 * @param int $varClos number of days to consider as recent
 * @param int $rankdoc position of document ID in $Fields[$i]
 * @param int $length lenght of text to keep in truncate fonction
 * @param boolean $restriction return details or not in case of member areas.
 * @param int $var type of the element, 1, 2 or none
 * @param string 'asc' or 'desc', date sort order, by default desc
 *
 * @return array information about recent and active elements sorted by modification date. If :
 * $var = 2 (parent's fileid, modification date, author, first or second language parent's title,
 *           truncated first language text, first or second language parent's category)
 * $var = 1 (fileid, modification date, author, empty, truncated first language text)
 * $var = other (fileid, modification date, author, title, truncated first or second language text,
 *               first or second language category)
 */
function SelectRecentPostFileByStatusLN($fields, $varClos, $rankDoc, $length,
                                        $restriction = '', $var = '', $sort = 'desc')
{
    global $lng, $lang, $ln_web12, $ln_web13, $ln_cfg;
    global $fileid, $status, $moddate, $author;
    global $fielda1, $fielda2, $fieldb1, $fieldb2, $fieldc1, $fieldc2;
    $DataDB = array();
    $k = 0;
    $now_time_file = strtotime ('now'); // now date
    $file_time_past = strtotime ('-' . $varClos . ' day'); // past date
    $nbFields = count($fields);
    for ($i = 0; $i < $nbFields; $i++) {
        // date of file modification with hour modification
        $param_file_time = @filemtime(CHEMIN . DATAREP . 'doc' . $fields[$i][$rankDoc] . INCEXT)
                           + ($ln_cfg[3] * 3600);
        // to speed up the test we compare the modification date of the file
        // return by the system, not the one store in the file.
        if ($param_file_time <= $now_time_file && $param_file_time > $file_time_past) {
            ReadDoc(DBBASE . $fields[$i][$rankDoc]);
            if ($status == 'a') {
                // If restricted so no details
                $affiche_0 = ($restriction == 'nodetails') ? array(0 => $ln_web13) :
                                            SplitText(KeepNotHtmlCharLN($fieldc1), $length);
                $affiche_1 = ($restriction == 'nodetails') ? array(0 => $ln_web13) :
                                            SplitText(KeepNotHtmlCharLN($fieldc2), $length);
                $DataDB[$k][0] = $fileid;
                $DataDB[$k][1] = FormatDate($moddate);
                $DataDB[$k][6] = $moddate;
                $DataDB[$k][2] = ($restriction == 'nodetails') ? $ln_web12 : $author;
                // for articles and blogs reactions
                if ($var == 2) {
                    $DataDB[$k][0] = $fielda2; // Parent's id
                    ReadDoc(DBBASE . $fielda2);
                    $DataDB[$k][3] = ($lng == $lang[0]) ? $fieldb1 : $fieldb2; // Parent's title
                    $DataDB[$k][4] = $affiche_0[0]; // First language truncated text
                    $DataDB[$k][5] = ($lng == $lang[0]) ? $fielda1 : $fielda2; // Parent's category
                }
                // For Guestbook
                else if ($var == 1) {
                    $DataDB[$k][3] = '';
                    $DataDB[$k][4] = $affiche_0[0]; // First language truncated text
                }
                // For text in two languages, articles, download, blog...
                else {
                    if ($lng == $lang[0]) {
                        $DataDB[$k][3] = $fieldb1; // First language title
                        $DataDB[$k][4] = $affiche_0[0]; // First language truncated text
                        $DataDB[$k][5] = $fielda1; // First language cat
                    } else {
                        $DataDB[$k][3] = $fieldb2; // Second language title
                        $DataDB[$k][4] = $affiche_1[0]; // Second language truncated text
                        $DataDB[$k][5] = $fielda2; // Second language cat
                    }
                }
                $k++;
            }
        }
    }
    usortLN($DataDB, $sort);
    return $DataDB;
}
/**
 * List all recent post on forum from an array of elements
 * and return an array of informations about them.
 *
 * @param array $fiels Array of array, wich came from ReadDBFields(DBType) or SelectDBFields(Type,'a','')
 * @param int $varClos number of days to consider as recent
 * @param int $length lenght of text to keep in truncate fonction
 * @param int $varNum number of message to display
 * @param boolean $restriction return truncated text or no text
 * @param string 'asc' or 'desc', date sort order, by default desc
 *
 * @return array information about recent and active elements sorted by modification date. If :
 * (parent's fileid, modification date, author, first or second language parent's title,
 *  truncated first language text, first or second language parent's category)
 */
function SelectRecentForumPostByStatusLN($fields, $varClos, $length, $varNum,
                                         $restriction = '', $sort = 'desc')
{
    global $serviz, $forum, $page, $lng, $lang, $web370, $web371, $ln_web12, $ln_web13, $ln_cfg;
    global $fileid, $status, $creadate, $moddate, $author;
    global $fielda1, $fielda2, $fieldb1, $fieldb2, $fieldc1, $fieldc2, $fieldmod;

    if (!empty($fields)) {
        @sort($fields);
        if ($serviz[18] == 'on') {
            $dbworkcat = ReadDBFields(DBFORUMCAT);
        }
        $dbfor = ReadDBFields(DBFORUM);
        $DataDB = array();
        $j = 0;
        $l = ($lng == $lang[0])?0 : 1;

        $newdate = date('YmdHi', time() - (86400 * $forum[8])); // dlai pour nouveau
        $messtop = '<img src="' . CHEMIN . 'inc/img/general/msg_t.gif" alt="' . $web370
                    . '" style="vertical-align:-5px" height="16px" />';
        $messnew = '<img src="' . CHEMIN . 'inc/img/general/msg_n.gif" alt="' . $web371
                    . '" style="vertical-align:-5px" height="16px" />';

        // We use the last $varNum thread of the last $varClos day
        $now_time_file= strtotime ('now');
        //$file_time_futur= strtotime ('+' . $varClos . ' day'); // future date
        $file_time_past= strtotime ('-' . $varClos . ' day'); // past date

        // For Coolforum plugin
        if ($ln_cfg[2] == 'cf') {
            include CHEMIN . 'plugins/coolforum/lang/' . $lng . '-coolforum.inc';
            if(FileDBExist(CHEMIN . 'plugins/coolforum/cf_config.inc')) {
                include CHEMIN . 'plugins/coolforum/cf_config.inc';
                include_once CHEMIN . 'plugins/coolforum/coolfunctions.php';
            }
            // Dterminer la langue pour les images
            if (empty($userprefs[10])) {
                $choixskin = $page[14];
            } else {
                $choixskin = $userprefs[10];
            }
            // Test si fichier skin dispo
            if (!is_dir(CHEMIN . 'plugins/coolforum/skins/' . $choixskin)) {
                $repimg = 'skins/defaut/img' . $lng;
            } else {
                $repimg = 'skins/' . $choixskin . '/img' . $lng;
            }
            if (!is_dir(CHEMIN . 'plugins/coolforum/' . $repimg)) {
                $repimg = 'skins/defaut/imgen';
            }
            if (!empty($userprefs[1])) {
                $cfdbmsg = array();
                $cfdbmsg = ReadDBFields(USEREP2 . $userprefs[1] . DBEXT);
                if(!empty($cfdbmsg[31][0]) &&
                         FileDBExist(CHEMIN . 'data/cforum/groups/' . $cfdbmsg[31][0] . '.inc')) {
                    include CHEMIN . 'data/cforum/groups/' . $cfdbmsg[31][0] . '.inc';
                }
            }
            if(!empty($gmembres) && !empty($gvisitors)) {
                include CHEMIN . 'plugins/coolforum/inc/access.inc';
            }
        }

        // Begin list of post
        $startLoopIdx = count($fields) - 1;
        $endLoopIdx = max(0, count($fields) - $varNum);
        for ($i = $startLoopIdx; $i >= $endLoopIdx; $i--) {
            // date of file modification with hour modification
            $param_file_time = @filemtime(CHEMIN . DATAREP . 'doc' . $fields[$i][3] . INCEXT)
                               + ($ln_cfg[3] * 3600);
            // to speed up the test we compare the modification date of the file
            // return by the system, not the one store in the file.
            if ($param_file_time <= $now_time_file && $param_file_time > $file_time_past) {
                $catnum = ''; $idnum = ''; $repnum = '';
                ReadDoc(DBBASE . $fields[$i][3]);
                if ($fielda2 == '0') { // first post of a thread
                    $DataDB[$j][0] = $fileid; // first post id
                    $DataDB[$j][3] = strip_tags($fieldb1); // subject title
                } else { // it's an answer
                    for ($k = 0; $k < count($dbfor); $k++) {
                        if ($fielda1 == $dbfor[$k][1]) {
                            $fieldb2 = $dbfor[$k][12]; // first post id
                            $DataDB[$j][0] = $dbfor[$k][2]; // id first post
                            $DataDB[$j][3] = strip_tags($dbfor[$k][5]); // subject title
                            $nbrep = $dbfor[$k][7]; // number of answers
                            $repnum = $fields[$i][2]; // answer number
                        }
                    }
                }
                $catnum = $fieldb2; // Categorie id
                for ($k = 0; $k < count($dbworkcat); $k++) {
                    if ($dbworkcat[$k][0] == $fieldb2) {
                      $DataDB[$j][5] = $dbworkcat[$k][$l+1]; // Categorie name
                    }
                }
                // For Coolforum plugin
                if(FileDBExist(CHEMIN . DATAREP . 'cforum/modo/' . $DataDB[$j][0] . INCEXT)
                             && $ln_cfg[2] == 'cf') {
                    $DataDB[$j][4] = $stdoc2; // waiting validation
                } else {
                    $tabc = ($restriction == 'nodetails') ? array(0 => $ln_web13) :
                                            SplitText(KeepNotHtmlCharLN($fieldc1),$length);
                    $DataDB[$j][4] = $tabc[0]; // truncated text
                }
                $DataDB[$j][1] = FormatDate($creadate); // creation date
                $DataDB[$j][6] = $creadate;
                // For Coolforum plugin
                if ($ln_cfg[2] == 'cf') {
                    $cgood = 0;
                    for ($ij = 0; $ij < count($private); $ij++) {
                        if($fieldb2 == $private[$ij][0]) {
                            $cgood = 1;
                        }
                    }
                    if($cgood == 0) {
                        $varNum++; $j--;
                    } else {
                        $DataDB[$j][1] .= '&nbsp;' . FindCookie($repimg,$catnum,$DataDB[$j][0],$fielda1,$author);
                    }
                } else {
                    if ($newdate < $creadate || $newdate < $moddate) {
                        $DataDB[$j][1] = FormatDate($creadate) . '&nbsp;' . $messnew;
                    }
                    if ($moddate != $creadate) {
                        if ($moddate > date('YmdHi')) {
                            $DataDB[$j][1] = FormatDate(date('YmdHi')) . '&nbsp;' . $messtop;
                            $DataDB[$j][6] = date('YmdHi');
                        } else if ($fieldmod != '') {
                            $datemod = explode('#', $fieldmod);
                            $DataDB[$j][1] = FormatDate($datemod[2]);
                            $DataDB[$j][6] = $datemod[2];
                        } else {
                            $DataDB[$j][1] = FormatDate($moddate);
                            $DataDB[$j][6] = $moddate;
                        }
                    }
                }
                $idnum = (ceil($repnum / $serviz[20])); // page number
                $DataDB[$j][0] .= '&amp;cat=' . $catnum . '&amp;id=' . $idnum . '#' . $repnum;
                $DataDB[$j][2] = ($restriction == 'nodetails') ? $ln_web12 : $author; // post author
                $j++;
            }
        }
        usortLN($DataDB, $sort);
        return $DataDB;
    }
    return '';
}
/**
 * List all recent active elements (docXXX.inc) from an array of elements
 * and return an array of informations about them.
 *
 * @param array $fiels Array of array, wich came from ReadDBFields(DBType) or SelectDBFields(Type,'a','')
 * @param int $varClos number of days to consider as recent
 * @param int $varNext number of days to consider as future
 * @param int $rankdoc position of document ID in $Fields[$i]
 * @param int $length lenght of text to keep in truncate fonction
 * @param boolean $restriction return truncated text or no text
 * @param string 'asc' or 'desc', date sort order, by default desc
 *
 * @return array information about recent and active elements sorted by modification date.
 * If :
 * $var = 2 (parent's fileid, modification date, author, first or second language parent's title,
 *           truncated first language text, first or second language parent's category)
 * $var = 1 (fileid, modification date, author, empty, truncated first language text)
 * $var = other (fileid, modification date, author, title, truncated first or second language text,
 *               first or second language category)
 */
function SelectAgendaPostFileByStatusLN($fields, $varClos, $varNext, $rankDoc, $length,
                                        $restriction = '', $sort = 'desc')
{
    global $lng, $lang, $ln_web12, $ln_web13;
    global $fileid, $status, $moddate, $author;
    global $fielda1, $fielda2, $fieldb1, $fieldb2, $fieldc1, $fieldc2;
    $DataDB = array();
    $k = 0;
    $event_time_past = strtotime (date('m/d/Y')) - ($varClos * 86400);
    $event_time_futur = strtotime (date('m/d/Y')) + ($varNext * 86400);
    $nbFields = count($fields);
    for ($i = 0; $i < $nbFields; $i++) {
        $param_file_time = strtotime(ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$',
                                                  '\\2/\\1/\\3', $fields[$i][0]));
        if ($param_file_time >= $event_time_past and $param_file_time <= $event_time_futur) {
            ReadDoc(DBBASE . $fields[$i][4]);
            if ($status == 'a') {
                // If restricted so no dtails
                $affiche_0 = ($restriction == 'nodetails') ? array(0 => $ln_web13) :
                                            SplitText(KeepNotHtmlCharLN($fieldc1),$length);
                $affiche_1 = ($restriction == 'nodetails') ? array(0 => $ln_web13) :
                                            SplitText(KeepNotHtmlCharLN($fieldc2),$length);
                $DataDB[$k][0] = $fileid;
                $DataDB[$k][1] = $fielda1; // event date
                $DataDB[$k][2] = ($restriction == 'nodetails') ? $ln_web12 : $author;
                if ($lng == $lang[0]) {
                    $DataDB[$k][4] = $affiche_0[0]; // First language truncated text
                } else {
                    $DataDB[$k][4] = $affiche_1[0]; // Second language truncated text
                }
                // YYYYMMDDhhmm date for usort
                $DataDB[$k][6] = ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$',
                                              '\\3\\2\\1', $fields[$i][0]) . '1200';
                $k++;
            }
        }
    }
    usortLN($DataDB, $sort);
    return $DataDB;
}
/**
 * Test the member area configuration and if the area is activated.
 *
 * @param int $section The guppy number of the section to test
 * @param string $lnConfig The display configuration for the area
 *
 * @return string The display to use
 */
function AreaDisplayLN($sectionNum, $lnConfig)
{
    global $members,$serviz,$userprefs,$ln_cfg;
    // member area and visitor is not a member
    if ($members[0] == 'on' && $members[$sectionNum] == 'on' && $userprefs[1] == '') {
        $rssmembre = $lnConfig;
    }
    // public area or visitor is a member
    else {
        $rssmembre = '';
    }
    switch ($sectionNum) {
        case 1: // articles
            if ($serviz[3] != 'on' && $serviz[22] != 'on') {
                if ($ln_cfg[4] != 'on') {
                    $rssmembre = 'nodisplay';
                }
            }
            break;
        case 2: // photos
            if ($serviz[9] != 'on') $rssmembre = 'nodisplay';
            break;
        case 3: // links
            if ($serviz[11] != 'on') $rssmembre = 'nodisplay';
            break;
        case 4: // faq
            if ($serviz[14] != 'on') $rssmembre = 'nodisplay';
            break;
        case 5: // forum
            if ($serviz[13] != 'on' && $ln_cfg[2] == 'gu') $rssmembre = 'nodisplay';
            break;
        case 12: // guestbook
            if ($serviz[12] != 'on') $rssmembre = 'nodisplay';
            break;
        case 13: // news
            if ($serviz[8] != 'on') $rssmembre = 'nodisplay';
            break;
        case 14: // agenda
            if ($serviz[47] != 'on') $rssmembre = 'nodisplay';
            break;
        case 15: // blog
            if ($serviz[53] != 'on') $rssmembre = 'nodisplay';
            break;
    }
    return $rssmembre;
}

/**
 * List all avaible/authorized RSS
 *
 * @param array $secList List of informations by section
 * @param int $indexToUse Index of $secList wich contains display information
 *
 * @return array for each section true or false *
 */
function ListAllRSSLN($secList, $indexToUse = 4)
{
    global $ln_cfg_rss;
    $RSSList = array();
    $RSSList[0] = false; $RSSGlobal = false;
    $RSSToDisplay = false;
    for ($i = 1; $i <= 13; $i++) {
        if ($secList[$i][$indexToUse] != 'nodisplay') {
            if ($ln_cfg_rss[$i][0] != '' || ($i == 1 && $ln_cfg_rss[$i][4] != '')) {
                $RSSList[$i] = true;
                if ($ln_cfg_rss[$i][3] != '') $RSSGlobal = true;
                $RSSToDisplay = true;
            } else {
                $RSSList[$i] = false;
            }
        }
    }
    if ($RSSGlobal) $RSSList[0] = true;
    if ($RSSToDisplay) return $RSSList;
    else return false;
}
